function AirbnbCity() {
    
    // Name for the visualisation to appear in the menu bar.
    this.name = 'AirBnB City: Demand';
  
    // Each visualisation must have a unique ID with no special
    // characters.
    this.id = 'airbnb-city';
  
    // Property to represent whether data has been loaded.
    this.loaded = false;
     
      this.preload = function() {
          var self = this;
          this.data = loadTable(
            './data/airbnb/airbndemand.csv', 'csv', 'header',
            // Callback function to set the value
            // this.loaded to true.
            function(table) {
              self.loaded = true;
            });     
    
        };
        
        this.setup = function() 
        {
          if (!this.loaded) 
          {
            console.log('Data not yet loaded');
            return;
          }
      
          // Create a select DOM element.
          this.select = createSelect();
          this.select.position(350, 40);
      
          // Fill the options with all year .
          var year = this.data.columns;
          // First entry is empty.
          for (let i = 1; i < year.length; i++) 
          {
            this.select.option(year[i]);
          }
        };  
      
     
      this.draw = function()
      {  
        if (!this.loaded) {
          console.log('Data not yet loaded');
          return;
        }
    var yearsData = this.select.value();
    var yearPrev = yearsData - 1;
    // Get the column of raw data for yearsData.
    var col = this.data.getColumn(yearsData);
  
        
    // Convert all data strings to numbers.
    col = stringsToNumbers(col);
    
    // labels from the table (the first item of each row).
    var labels = this.data.getColumn(0);
    
    // Colour to use for each category.
    var colors = ['blue', 'red', 'green', 'pink', 'purple', 'yellow','black','grey','skyblue','maroon'];
    
    // Key to use to determine bar size
    var key1 = max(col);
    
      // Upper heading of current and previous year
      textSize(18);
      fill('black');
      text(this.name, width *0.5, 20);
     
    
      var position = 100;
      var bar_widtharea = width - 100;
      var bar_width = bar_widtharea / col.length;
      var fontsize = bar_width / bar_widtharea * 100;
      
      for(i = 0; i < col.length; i++)
      {
      fill(colors[i]);
      stroke('white');
      rect(position,30,bar_width,col[i] / key1 * 100 * 4.5);
      
      textSize(fontsize);
        fill('black');      
        noStroke(0);
        text(labels[i] + ' ' + col[i], bar_width * i + 100, col[i] / key1 * 100 * 5 + 20);
      
        position += bar_width;
      } 
              
      // Lower Heading
      textSize(18);
      fill('black');
      text('For the Year '+yearsData, width/2 - 100, height - 50);
    
      } 
    
    }
    
