function LondonTraffic() {
    // Name for the visualisation to appear in the menu bar.
    this.name = 'London City: Traffic';
  
    // Each visualisation must have a unique ID with no special
    // characters.
    this.id = 'london-traffic';
  
    // Property to represent whether data has been loaded.
    this.loaded = false;

    this.preload = function() {
        var self = this;
        this.data = loadTable(
          './data/london-traffic/london-traffic.csv', 'csv', 'header',
          // Callback function to set the value
          // this.loaded to true.
          function(table) {
            self.loaded = true;
          });
      };
    
      this.setup = function() {
        if (!this.loaded) {
          console.log('Data not yet loaded');
          return;
        }
    
        // Create a select DOM element.
        this.select = createSelect();
        this.select.position(350, 40);
    
        // Fill the options with all year .
        var year = this.data.columns;
        // First entry is empty.
        for (let i = 1; i < year.length; i++) {
          this.select.option(year[i]);
        }
      };
    
      this.destroy = function() {
        this.select.remove();
      };
    
      // Create a new pie chart object.
      this.pie = new PieChart(width / 2, height / 2, width * 0.4);
    
      this.draw = function() {
        if (!this.loaded) {
          console.log('Data not yet loaded');
          return;
        }
    
        // Get the value of the years we're interested in from the
        // select item.
        var yearsData = this.select.value();
    
        // Get the column of raw data for yearsData.
        var col = this.data.getColumn(yearsData);
    
        // Convert all data strings to numbers.
        col = stringsToNumbers(col);
    
        // Copy the row labels from the table (the first item of each row).
        var labels = this.data.getColumn(0);
    
        // Colour to use for each category.
        var colours = ['blue', 'red', 'green', 'pink', 'purple', 'yellow','black','grey','skyblue','maroon'];
    
        // Make a title.
        var title = 'London City Traffic In ' + yearsData;
    
        // Draw the pie chart!
        this.pie.draw(col, labels, colours, title);
      };
  
  
  }